#!/bin/perl

###########################################################################
# WWWBoard
# Version 2.0 ALPHA 2
# Created by Matt Wright
# Created on:  10/21/95			Last Modified on:  11/25/95
# I can be reached at:			mattw@misha.net
# Scripts Found at:				http://www.worldwidemart.com/scripts/
###########################################################################

###########################################################################
# Define Variables

$basedir = "/usr/people/otakubowler/web_docs/wwwboard";
$baseurl = "http://idfx.com/otakubowler/wwwboard";
$cgi_url = "http://idfx.com/cgi-bin/wwwboard.pl";

$mesgdir = "messages";
$datafile = "data.txt";
$mesgfile = "bbs.html";
$faqfile = "faq.html";

$ext = "html";

$title = "Otaku BBS";

# Done
###########################################################################

###########################################################################
# Configure Options

$show_faq = 0;		# 1 - YES; 0 = NO
$allow_html = 1;	# 1 = YES; 0 = NO
$quote_text = 1;	# 1 = YES; 0 = NO
$subject_line = 0;	# 0 = Quote Subject Editable; 1 = Quote Subject 
			#	UnEditable; 2 = Don't Quote Subject, Editable.
$use_time = 1;		# 1 = YES; 0 = NO

# Done
###########################################################################

# Get the Data Number
&get_number;

# Get Form Information
&parse_form;

# Put items into nice variables
&get_variables;

# Open the new file and write information to it.
&new_file;

# Open the Main WWWBoard File to add link
&main_page;

# Now Add Thread to Individual Pages
if ($num_followups >= 1) {
   &thread_pages;
}

# Return the user HTML
&return_html;

# Increment Number
&increment_num;

############################
# Get Data Number Subroutine

sub get_number {
   open(NUMBER,"$basedir/$datafile");
   $num = <NUMBER>;
   close(NUMBER);
   if ($num == 99999)  {
	  $num = "1";
   }
   else {
	  $num++;
   }
}

#######################
# Parse Form Subroutine

sub parse_form {

   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
	  ($name, $value) = split(/=/, $pair);

	  # Un-Webify plus signs and %-encoding
	  $value =~ tr/+/ /;
	  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	  $value =~ s/<!--(.|\n)*-->//g;

	  if ($allow_html != 1) {
		 $value =~ s/<([^>]|\n)*>//g;
	  }
	  else {
		 unless ($name eq 'body') {
		$value =~ s/<([^>]|\n)*>//g;
		 }
	  }

	  $FORM{$name} = $value;
   }

}

###############
# Get Variables

sub get_variables {

   if ($FORM{'followup'}) {
	  $followup = "1";
	  @followup_num = split(/,/,$FORM{'followup'});
	  $num_followups = @followups = @followup_num;
	  $last_message = pop(@followups);
	  $origdate = "$FORM{'origdate'}";
	  $origname = "$FORM{'origname'}";
	  $origsubject = "$FORM{'origsubject'}";
   }
   else {
	  $followup = "0";
   }

   if ($FORM{'name'}) {
	  $name = "$FORM{'name'}";
	  $name =~ s/"//g;
	  $name =~ s/<//g;
	  $name =~ s/>//g;
	  $name =~ s/\&//g;
   }
   else {
	  &error(no_name);
   }

   if ($FORM{'email'} =~ /.*\@.*\..*/) {
	  $email = "$FORM{'email'}";
   }

   if ($FORM{'subject'}) {
	  $subject = "$FORM{'subject'}";
	  $subject =~ s/\&/\&amp\;/g;
	  $subject =~ s/"/\&quot\;/g;
   }
   else {
	  &error(no_subject);
   }

   if ($FORM{'url'} =~ /.*\:.*\..*/ && $FORM{'url_title'}) {
	  $message_url = "$FORM{'url'}";
	  $message_url_title = "$FORM{'url_title'}";
   }

   if ($FORM{'img'} =~ /.*tp:\/\/.*\..*/) {
	  $message_img = "$FORM{'img'}";
   }

   if ($FORM{'body'}) {
	  $body = "$FORM{'body'}";
	  $body =~ s/\cM//g;
	  $body =~ s/\n\n/<p>/g;
	  $body =~ s/\n/<br>/g;

	  $body =~ s/&lt;/</g; 
	  $body =~ s/&gt;/>/g; 
	  $body =~ s/&quot;/"/g;
   }
   else {
	  &error(no_body);
   }

   if ($quote_text == 1) {
	  $hidden_body = "$body";
	  $hidden_body =~ s/</&lt;/g;
	  $hidden_body =~ s/>/&gt;/g;
	  $hidden_body =~ s/"/&quot;/g;
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   if ($sec < 10) {
	  $sec = "0$sec";
   }
   if ($min < 10) {
	  $min = "0$min";
   }
   if ($hour < 10) {
	  $hour = "0$hour";
   }
   if ($mon < 10) {
	  $mon = "0$mon";
   }
   if ($mday < 10) {
	  $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("January","February","March","April","May","June","July","August",
		"September","October","November","December");

   if ($use_time == 1) {
	  $date = "$hour\:$min $month/$mday/$year";
   }
   else {
	  $date = "$month/$mday/$year";
   }
   chop($date) if ($date =~ /\n$/);

   $long_date = "$months[$mon] $mday, 19$year at $hour\:$min";
}	   

#####################
# New File Subroutine

sub new_file {

   open(NEWFILE,">$basedir/$mesgdir/$num\.$ext") || die $!;
   print NEWFILE "<html>\n";
   print NEWFILE "	<head>\n";
   print NEWFILE "	  <title>$subject</title>\n";
   print NEWFILE "</head>\n";
   print NEWFILE "<body bgcolor=#FFFFFF text=#333333 link=#ab0716 vlink=#808080>\n";
   print NEWFILE " <center>\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/logo_orange.gif\" alt=\"[otaku logo]\" \n";
   print NEWFILE "align=middle width=392 height=136 border=0>\n";
   print NEWFILE "<br><br>\n";
   
   print NEWFILE "<table border=0 cellspcaing=5 cellpadding=0>\n";
   print NEWFILE "<tr>\n";
   print NEWFILE "<td><a href=\"/otakubowler/winner.html\">\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/greyupdate.gif\" alt=\"to Update\" width=\"66\" \n";
   print NEWFILE "height=\"14\" border=\"0\"></a>\n";
   print NEWFILE "</td>\n";
   
   print NEWFILE "<td><a href=\"/otakubowler/past.html\">\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/greyarchive.gif\" alt=\"to Archive\" width=\"66\" height=\"14\"\n";
   print NEWFILE " border=\"0\"></a>\n";
   print NEWFILE "</td>\n";
   
   print NEWFILE "<td><a href=\"/otakubowler/palace.html\">\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/greypalace.gif\" alt=\"to Palace\" width=\"66\" height=\"14\" \n";
   print NEWFILE "border=\"0\"></a>\n";
   print NEWFILE "</td>\n";
   
   print NEWFILE "<td><a href=\"/otakubowler/etiquette.html\">\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/greyettiquette.gif\" alt=\"to etiquette\" \n";
   print NEWFILE "width=\"66\" height=\"14\" border=\"0\"></a>\n";
   print NEWFILE "</td>\n";
   print NEWFILE "<td><a href=\"/otakubowler/profile.html\">\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/greyprofile.gif\" alt=\"to Profiile\" width=\"66\" \n";
   print NEWFILE "height=\"14\" border=\"0\"></a>\n";
   print NEWFILE "</td>\n";
   
   print NEWFILE "<td><a href=\"/otakubowler/index.html\">\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/greyzone.gif\" alt=\"to Index page\" width=\"66\" \n";
   print NEWFILE "height=\"14\" border=\"0\"></a>\n";
   print NEWFILE "</td>\n";
   print NEWFILE "</tr>\n";
   print NEWFILE "</table>\n";

   print NEWFILE "<h2>$subject</h2>\n";
   print NEWFILE "</center>\n";
   print NEWFILE "<hr size=1 width=60%>\n";
   if ($show_faq == 1) {
	  print NEWFILE "<center>[ <a href=\"#followups\">Follow Ups</a> ] \n";
	  print NEWFILE "[ <a href=\"#postfp\">Post Followup</a> ] \n";
	  print NEWFILE "[ <a href=\"$baseurl/$mesgfile\">$title</a> ] \n";
	  print NEWFILE "[ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
	  print NEWFILE "<center>[ <a href=\"#followups\">Follow Ups</a> ] \n";
	  print NEWFILE "[ <a href=\"#postfp\">Post Followup</a> ] \n";
	  print NEWFILE "[ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
   print NEWFILE "<hr size=1 width=60%><p>\n";

   print NEWFILE "Posted by ";

   if ($email) {
	  print NEWFILE "<a href=\"mailto:$email\">$name</a> on $long_date:<p>\n";
   }
   else {
	  print NEWFILE "$name on $long_date:<p>\n";
   }

   if ($followup == 1) {
	  print NEWFILE "In Reply to: <a href=\"$last_message\.$ext\">$origsubject</a> posted by ";

	  if ($origemail) {
		 print NEWFILE "<a href=\"$origemail\">$origname</a> on $origdate:<p>\n";
	  }
	  else {
		 print NEWFILE "$origname on $origdate:<p>\n";
	  }
   }

   if ($message_img) {
	  print NEWFILE "<center><img src=\"$message_img\"></center><p>\n";
   }
   print NEWFILE "$body\n";
   print NEWFILE "<br>\n";
   if ($message_url) {
	  print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
   }
   print NEWFILE "<br><hr size=4 width=60%><p>\n";
   print NEWFILE "<a name=\"followups\">Follow Ups:</a><br>\n";
   print NEWFILE "<ul><!--insert: $num-->\n";
   print NEWFILE "</ul><!--end: $num-->\n";
   print NEWFILE "<br><hr size=4 width=60%><p>\n";
   print NEWFILE "<a name=\"postfp\">Post a Followup</a><p>\n";
   print NEWFILE "<form method=POST action=\"$cgi_url\">\n";
   print NEWFILE "<input type=hidden name=\"followup\" value=\"";
   if ($followup == 1) {
	  foreach $followup_num (@followup_num) {
		 print NEWFILE "$followup_num,";
	  }
   }
   print NEWFILE "$num\">\n";
   print NEWFILE "<input type=hidden name=\"origname\" value=\"$name\">\n";
   if ($email) {
	  print NEWFILE "<input type=hidden name=\"origemail\" value=\"$email\">\n";
   }
   print NEWFILE "<input type=hidden name=\"origsubject\" value=\"$subject\">\n";
   print NEWFILE "<input type=hidden name=\"origdate\" value=\"$long_date\">\n";
   print NEWFILE "Name: <input type=text name=\"name\" size=50><br>\n";
   print NEWFILE "E-Mail: <input type=text name=\"email\" size=50><p>\n";
   if ($subject_line == 1) {
	  if ($subject_line =~ /^Re:/) {
		 print NEWFILE "<input type=hidden name=\"subject\" value=\"$subject\">\n";
		 print NEWFILE "Subject: <b>$subject</b><p>\n";
	  }
	  else {
		 print NEWFILE "<input type=hidden name=\"subject\" value=\"Re: $subject\">\n";
		 print NEWFILE "Subject: <b>Re: $subject</b><p>\n";
	  }
   } 
   elsif ($subject_line == 2) {
	  print NEWFILE "Subject: <input type=text name=\"subject\" size=60><p>\n";
   }
   else {
	  if ($subject =~ /^Re:/) {
		 print NEWFILE "Subject: <input type=text name=\"subject\"value=\"$subject\"\n";
		 print NEWFILE "size=60><p> \n";
	  }
	  else {
		 print NEWFILE "Subject: <input type=text name=\"subject\" value=\"Re: $subject\" \n";
		 print NEWFILE "size=60><p>\n";
	  }
   }
   print NEWFILE "Comments:<br>\n";
   print NEWFILE "<textarea name=\"body\" COLS=65 ROWS=10>\n";
   if ($quote_text == 1) {
	  @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
	  foreach $chunk_of_body (@chunks_of_body) {
		 @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
		 foreach $line_of_body (@lines_of_body) {
			print NEWFILE ": $line_of_body\n";
		 }
		 print NEWFILE "\n";
	  }
   }
   print NEWFILE "</textarea>\n";
   print NEWFILE "<p><br><br><br><br>\n";
   
   print NEWFILE "<input type=submit value=\"Submit Follow Up\"> <input type=reset>\n";
   print NEWFILE "<p><hr size=1 width=60%>\n";
   if ($show_faq == 1) {
	  print NEWFILE "<center>[ <a href=\"#followups\">Follow Ups</a> ] \n";
	  print NEWFILE "[ <a href=\"#postfp\">Post Followup</a> ] \n";
	  print NEWFILE "[ <a href=\"$baseurl/$mesgfile\">$title</a> ] \n";
	  print NEWFILE "[ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
	  print NEWFILE "<center>[ <a href=\"#followups\">Follow Ups</a> ] \n";
	  print NEWFILE "[ <a href=\"#postfp\">Post Followup</a> ] \n";
	  print NEWFILE "[ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
   
   print NEWFILE "<hr size=1 width=60%>\n";
   print NEWFILE "<center>\n";
   print NEWFILE "<table cellspacing=5>\n";
   print NEWFILE "<tr>\n";
   print NEWFILE "<td rowspan=2 valign=middle align=center>\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print NEWFILE " height=\"25\" border=\"0\">\n";
   print NEWFILE "</td>\n";
   print NEWFILE "<td valign=middle align=center><font size=2>\n";
   print NEWFILE "<a href=\"/otakubowler/index.html\">Otaku<br>Zone<br></a>\n";
   print NEWFILE "</font>\n";
   print NEWFILE "</td>\n";
   
   print NEWFILE "<td rowspan=2 valign=middle align=center>\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print NEWFILE " height=\"25\" border=\"0\">\n";
   print NEWFILE "</td>\n";
   print NEWFILE "<td valign=middle><font size=2>\n";
   print NEWFILE "<a href=\"/otakubowler/palace.html\">Palace</a></font>\n";
   print NEWFILE "</td>\n";

   print NEWFILE "<td rowspan=2 valign=middle align=center>\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/pin.jpg\" align=centerr width=\"9\" \n";
   print NEWFILE " height=\"25\" border=\"0\">\n";
   print NEWFILE "</td>\n";
   print NEWFILE "<td valign=middle><font size=2>\n";
   print NEWFILE "<a href=\"/otakubowler/etiquette.html\">Etiquette</a></font>\n";
   print NEWFILE "</td>\n";

   print NEWFILE "<td rowspan=2 valign=middle align=center>\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print NEWFILE " height=\"25\" border=\"0\"></td>\n";
   print NEWFILE "<td valign=middle align=center><font size=2>\n";
   print NEWFILE "<a href=\"/otakubowler/winner.html\">News<br>Update</a></font>\n";
   print NEWFILE "</td>\n";

   print NEWFILE "<td rowspan=2 valign=middle align=center>\n";
   print NEWFILE "<img src=\"/otakubowler/imgs/pin.jpg\" align=centerwidth=\"9\" \n";
   print NEWFILE " height=\"25\" border=\"0\"></td>\n";
   print NEWFILE "<td valign=middle align=center><font size=2>\n";
   print NEWFILE "<a href=\"/otakubowler/past.html\">News<br>Archive</a></font>\n";
   print NEWFILE "</td>\n";
   print NEWFILE "</tr>\n";

   print NEWFILE "</table>\n";
   print NEWFILE "</center>\n";


   print NEWFILE "</body></html>\n";
   close(NEWFILE);
}

###############################
# Main WWWBoard Page Subroutine

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || die $!;
   @main = <MAIN>;
   close(MAIN);

   open(MAIN,">$basedir/$mesgfile") || die $!;
   if ($followup == 0) {
	  foreach $main_line (@main) {
		 if ($main_line =~ /<!--begin-->/) {
			print MAIN "<!--begin-->\n";
			print MAIN "<!--top: $num--><li>\n";
			print MAIN "<a href=\"$mesgdir/$num\.$ext\">$subject</a> - \n";
			print MAIN "<b>$name</b> <i>$date</i>\n";
			print MAIN "(<!--responses: $num-->0)\n";
			print MAIN "<ul><!--insert: $num-->\n";
			print MAIN "</ul><!--end: $num-->\n";
		 }
		 else {
			print MAIN "$main_line";
		 }
	  }
   }
   else {
	  foreach $main_line (@main) {
	 $work = 0;
		 if ($main_line =~ /<ul><!--insert: $last_message-->/) {
			print MAIN "<ul><!--insert: $last_message-->\n";
			print MAIN "<!--top: $num--><li>\n";
			print MAIN "<a href=\"$mesgdir/$num\.$ext\">$subject</a> - \n";
			print MAIN "<b>$name</b> <i>$date</i>\n";
			print MAIN "(<!--responses: $num-->0)\n";
			print MAIN "<ul><!--insert: $num-->\n";
			print MAIN "</ul><!--end: $num-->\n";
		 }
		 elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
			$response_num = $1;
			$num_responses = $2;
			$num_responses++;
			foreach $followup_num (@followup_num) {
			   if ($followup_num == $response_num) {
				  print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		  $work = 1;
			   }
			}
			if ($work != 1) {
			   print MAIN "$main_line";
			}
		 }
		 else {
			print MAIN "$main_line";
		 }
	  }
   }
   close(MAIN);
}

############################################
# Add Followup Threading to Individual Pages
sub thread_pages {

   foreach $followup_num (@followup_num) {
	  open(FOLLOWUP,"$basedir/$mesgdir/$followup_num\.$ext");
	  @followup_lines = <FOLLOWUP>;
	  close(FOLLOWUP);

	  open(FOLLOWUP,">$basedir/$mesgdir/$followup_num\.$ext");
	  foreach $followup_line (@followup_lines) {
		 $work = 0;
		 if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
			print FOLLOWUP "<ul><!--insert: $last_message-->\n";
			print FOLLOWUP "<!--top: $num-->\n";
			print FOLLOWUP "<li><a href=\"$num\.$ext\">$subject</a> \n";
			print FOLLOWUP "<b>$name</b> <i>$date</i>\n";
			print FOLLOWUP "(<!--responses: $num-->0)\n";
			print FOLLOWUP "<ul><!--insert: $num-->\n";
			print FOLLOWUP "</ul><!--end: $num-->\n";
		 }
		 elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
			$response_num = $1;
			$num_responses = $2;
			$num_responses++;
			foreach $followup_num (@followup_num) {
			   if ($followup_num == $response_num) {
				  print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
				  $work = 1;
			   }
			}
			if ($work != 1) {
			   print FOLLOWUP "$followup_line";
			}
		 }
		 else {
			print FOLLOWUP "$followup_line";
		 }
	  }
	  close(FOLLOWUP);
   }
}

sub return_html {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Message Added: $subject</title></head>\n";
   print "<body bgcolor=#FFFFFF text=#333333 link=#ab0716 vlink=#808080>\n";
   print "<center><h2>Message Added: $subject</h2></center>\n";
   print "The following information was added to the message board:\n";
    print "<p><hr size=1 width=60%><p>\n";
   print "<b>Name:</b> $name<br>\n";
   print "<b>E-Mail:</b> $email<br>\n";
   print "<b>Subject:</b> $subject<br>\n";
   print "<b>Body of Message:</b><p>\n";
   print "$body<p>\n";
   if ($message_url) {
	  print "<b>Link:</b> <a href=\"$message_url\">$message_url_title</a><br>\n";
   }
   if ($message_img) {
	  print "<b>Image:</b> <img src=\"$message_img\"><br>\n";
   }
   print "<b>Added on Date:</b> $date<p>\n";
   print "<hr size=1 width=60%>\n";
   print "<center>\n";
   print "[ <a href=\"$baseurl/$mesgdir/$num\.$ext\">Go to Your Message</a> ] \n";
   print "[ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
  
   print "<hr width=60%>\n";
   print "<center>\n";
   print "<table cellspacing=5>\n";
   print "<tr>\n";
   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print " height=\"25\" border=\"0\">\n";
   print "</td>\n";
   print "<td valign=middle align=center><font size=2>\n";
   print "<a href=\"/otakubowler/index.html\">Otaku<br>Zone<br></a>\n";
   print "</font>\n";
   print "</td>\n";
   
   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print " height=\"25\" border=\"0\">\n";
   print "</td>\n";
   print "<td valign=middle><font size=2>\n";
   print "<a href=\"/otakubowler/palace.html\">Palace</a></font>\n";
   print "</td>\n";

   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=centerr width=\"9\" \n";
   print " height=\"25\" border=\"0\">\n";
   print "</td>\n";
   print "<td valign=middle><font size=2>\n";
   print "<a href=\"/otakubowler/etiquette.html\">Etiquette</a></font>\n";
   print "</td>\n";

   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print " height=\"25\" border=\"0\"></td>\n";
   print "<td valign=middle align=center><font size=2>\n";
   print "<a href=\"/otakubowler/winner.html\">News<br>Update</a></font>\n";
   print "</td>\n";

   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=centerwidth=\"9\" \n";
   print " height=\"25\" border=\"0\"></td>\n";
   print "<td valign=middle align=center><font size=2>\n";
   print "<a href=\"/otakubowler/past.html\">News<br>Archive</a></font>\n";
   print "</td>\n";
   print "</tr>\n";

   print "</table>\n";
   print "</center>\n";
   print "</body></html>\n";
}

sub increment_num {
   open(NUM,">$basedir/$datafile") || die $!;
   print NUM "$num";
   close(NUM);
}

sub error {
   $error = $_[0];

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name') {
	  print "<html><head><title>$title ERROR: No Name</title></head>\n";
	  print "<body bgcolor=#FFFFFF text=#333333 link=#ab0716 vlink=#808080>\n";
	  print "<center><h1>ERROR: No Name</h1></center>\n";
	  print "You forgot to fill in the 'Name' field in your posting.  \n";
	  print "Correct it below and re-submit.  The necessary fields are: Name, \n";
	  print "Subject and Message.<p><hr size=4 width=75%><p>\n";
	  &rest_of_form;
   }
   elsif ($error eq 'no_subject') {
	  print "<html><head><title>$title ERROR: No Subject</title></head>\n";
	  print "<body bgcolor=#FFFFFF text=#333333 link=#ab0716 vlink=#808080>\n";
	  print "<center><h1>ERROR: No Subject</h1></center>\n";
	  print "You forgot to fill in the 'Subject' field in your posting.\n";	 
	  print "Correct it below and re-submit.  The necessary fields are: Name, \n";
	  print "Subject and Message.<p><hr size=4 width=75%><p>\n";
	  &rest_of_form;
   }
   elsif ($error eq 'no_body') {
	  print "<html><head><title>$title ERROR: No Message</title></head>\n";
	  print "<body bgcolor=#FFFFFF text=#333333 link=#ab0716 vlink=#808080>\n";
	  print "<center><h1>ERROR: No Message</h1></center>\n";
	  print "You forgot to fill in the 'Message' fieldin your posting.	\n";
	  print "Correct it below and re-submit.	 \n";
	  print "The necessary fields are: Name, Subjectand Message.\n";
	  print "<p><hr size=4 width=75%><p>\n";
	  &rest_of_form;
   }
   else {
	  print "ERROR!	 Undefined.\n";
   }
   exit;
}

sub rest_of_form {

   print "<form method=POST action=\"$cgi_url\">\n";

   if ($followup == 1) {
	  print "<input type=hidden name=\"origsubject\" \n";
	  print "value=\"$FORM{'origsubject'}\">\n";
	  print "<input type=hidden name=\"origname\" \n";
	  print "value=\"$FORM{'origname'}\">\n";
	  print "<input type=hidden name=\"origemail\" \n";
	  print "value=\"$FORM{'origemail'}\">\n";
	  print "<input type=hidden name=\"origdate\" \n";
	  print "value=\"$FORM{'origdate'}\">\n";
	  print "<input type=hidden name=\"followup\" \n";
	  print "value=\"$FORM{'followup'}\">\n";
   }
   print "Name: <input type=text name=\"name\" \n";
   print "value=\"$FORM{'name'}\" size=50><br>\n";
   print "E-Mail: <input type=text name=\"email\" \n";
   print "value=\"$FORM{'email'}\" size=50><p>\n";
   if ($subject_line == 1) {
	  print "<input type=hidden name=\"subject\" \n";
	  print "value=\"$FORM{'subject'}\">\n";
	  print "Subject: <b>$FORM{'subject'}</b><p>\n";
   } 
   else {
	  print "Subject: <input type=text name=\"subject\" \n";
	  print "value=\"$FORM{'subject'}\" size=60><p>\n";
   }
   
   print "Message:<br>\n";
   print "<textarea COLS=65 ROWS=10 name=\"body\">\n";
   $FORM{'body'} =~ s/</&lt;/g;
   $FORM{'body'} =~ s/>/&gt;/g;
   $FORM{'body'} =~ s/"/&quot;/g;
   print "$FORM{'body'}\n";
   print "</textarea><p><br><br><br><br>\n";
   
   print "<input type=submit value=\"Post Message\"> <input type=reset>\n";
   print "</form>\n";
   print "<br><hr size=1 width=60%>\n";
   if ($show_faq == 1) {
	  print "<center>[ <a href=\"#followups\">Follow Ups</a> ] \n";
	  print "[ <a href=\"#postfp\">Post Followup</a> ] \n";
	  print "[ <a href=\"$baseurl/$mesgfile\">$title</a> ] \n";
	  print "[ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
	  print "<center>[ <a href=\"#followups\">Follow Ups</a> ] \n";
	  print "[ <a href=\"#postfp\">Post Followup</a> ] \n";
	  print "[ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
   
   print "<hr width=60%>\n";
   print "<center>\n";
   print "<table cellspacing=5>\n";
   print "<tr>\n";
   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print " height=\"25\" border=\"0\">\n";
   print "</td>\n";
   print "<td valign=middle align=center><font size=2>\n";
   print "<a href=\"/otakubowler/index.html\">Otaku<br>Zone<br></a>\n";
   print "</font>\n";
   print "</td>\n";
   
   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print " height=\"25\" border=\"0\">\n";
   print "</td>\n";
   print "<td valign=middle><font size=2>\n";
   print "<a href=\"/otakubowler/palace.html\">Palace</a></font>\n";
   print "</td>\n";

   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=centerr width=\"9\" \n";
   print " height=\"25\" border=\"0\">\n";
   print "</td>\n";
   print "<td valign=middle><font size=2>\n";
   print "<a href=\"/otakubowler/etiquette.html\">Etiquette</a></font>\n";
   print "</td>\n";

   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=center width=\"9\" \n";
   print " height=\"25\" border=\"0\"></td>\n";
   print "<td valign=middle align=center><font size=2>\n";
   print "<a href=\"/otakubowler/winner.html\">News<br>Update</a></font>\n";
   print "</td>\n";

   print "<td rowspan=2 valign=middle align=center>\n";
   print "<img src=\"/otakubowler/imgs/pin.jpg\" align=centerwidth=\"9\" \n";
   print " height=\"25\" border=\"0\"></td>\n";
   print "<td valign=middle align=center><font size=2>\n";
   print "<a href=\"/otakubowler/past.html\">News<br>Archive</a></font>\n";
   print "</td>\n";
   print "</tr>\n";

   print "</table>\n";
   print "</center>\n";
   print "</body></html>\n";
}
